//rutiny pro export do ruznych vystupnich souboru
const CWG_BUTTONS=4;     //pocet hodnot pro jedno CWG v poli v javascriptu
      CWG_PROPERTIES=8;
      IDX_NICK=0; IDX_NICKURL=1; IDX_DATESORT=2; IDX_DATETEXT=3; IDX_CWGID=4;
      IDX_IMG=5; IDX_CACHEID=6; IDX_CACHEURL=7;

procedure ExportSeznam(sFile:string); //exportuje obsah databaze jako prosty seznam
var s,sOut:string;
    tab:TSQLiteTable;
    i:integer;
begin
  DBOpen();
  sOut:='----- Katalog CWG -----';
  s:='SELECT Name,Version,Category,ID,Catalog FROM '+TABLE_CATALOG+' ORDER BY Name||" "||Version';
  tab:=CwgDB.GetTable(s,false);
  try
    i:=0;
    while not tab.eof do begin
      Int(i);
      s:=CRLF+IntToStr(i)+': '+UtfToAnsi(tab.FieldAsString(0))+', '+tab.FieldAsString(1)+', '
         +tab.FieldAsString(2)+', '+tab.FieldAsString(3)+', '+tab.FieldAsString(4);
      sOut:=sOut+s;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  sOut:=sOut+CRLF+CRLF+'----- Zskan CWG -----';
  s:='SELECT Name,Version,Category,ID FROM '+TABLE_FOUND+' ORDER BY Name||" "||Version';
  tab:=CwgDB.GetTable(s,false);
  try
    i:=0;
    while not tab.eof do begin
      Int(i);
      s:=CRLF+IntToStr(i)+': '+UtfToAnsi(tab.FieldAsString(0))+', '+tab.FieldAsString(1)+', '
         +tab.FieldAsString(2)+', '+tab.FieldAsString(3);
      sOut:=sOut+s;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  DBClose();
  StringToFile(sOut,sFile);
end;

function GetExportData(bSigitem,bCache:boolean;outcoding,sSort:string):TStringList;
var i:integer;
    s,scnt,ver,cache:string;
    tab:TSQLiteTable;
begin
  DBOpen(); //otevrit DB
  if(not FileExists(GetDBPathname())) then begin
    ShowMessage('ERR: Chyba otevreni databaze:'+CRLF+CRLF+GetDBPathname());
    GeoAbort();
  end;
  Result:=TStringList.Create();
  s:='SELECT my.Name, my.cnt, my.Version, my.CacheId '
    +' FROM '+TABLE_FOUND+' my '
    +' WHERE my.Category<>'''+AnsiToUtf(MY_CATEGORY)+'''';
  if(not bSigItem) then s:=s+CRLF+' and my.Category IN (''CWG'',''cwg'',''cle'',''ceg'',''swg'',''sle'',''seg'')';
  if(sSort='DATE') then s:=s+' order by my.DateFound'
  else if(sSort='CACHE') then s:=s+' order by my.CacheId'
  else s:=s+' order by my.Name';
  tab:=CwgDB.GetTable(s,false);
  i:=0;
  try
    while not tab.eof do begin
      if GeoBusyTest then Break;  //preruseno uzivatelem
      //Counter:=Counter+1;
      //GeoBusyProgress(Counter, max);
      // nactem CWG, prevedeme na pozadovane kodovani
      if(UpperCase(outcoding)='ASCII') then s:=UtfToAscii(tab.FieldAsString(0))
      else s:=UtfToCharset(tab.FieldAsString(0),outcoding);
           //s:=UtfToAnsi(tab.FieldAsString(0));
           //s:=(tab.FieldAsString(0));
      scnt:=tab.FieldAsString(1);
      ver:=tab.FieldAsString(2);
      cache:=Trim(tab.FieldAsString(3));
      if(ver>'1') then s:=s+' (verze '+ver+')';
      if(scnt>'1') then s:=s+' ['+scnt+' ks]';
      if(cache<>'') and (bCache) then s:=s+' {'+cache+'}';
      Result.Add(s);
      Inc(i);
      tab.next;                   // skok na dalsi
    end;
  finally
    if(tab<>nil) then tab.Free();
  end;
  DBClose();
end;

procedure ExportTxt(bSilent:boolean);
var a:TStringList;
    i,j,k,n:Integer;
    s,s1:string;
begin
  //OUTTXT_HORIZONTAL='1';        //1=tabulka je abecedne razena vodorovne, 0=svisle
  n:=StrToInt(OUTTXT_COLS);
  a:=GetExportData(false,true,OUTTXT_OUTCODING,'NAME'); //bez Sigitem, s ID kese
  s:='';
  if(OUTTXT_HORIZONTAL='1') then begin
    for i:=0 to a.Count-1 do begin
      for j:=0 to n-1 do begin
        if((i+j)<a.Count) then begin
          s:=s+IntToStr(i+j+1)+'. '+a[i+j];
          if(j<n-1) then s:=s+OUTTXT_SEPARATOR;
        end;
      end;
      s:=s+CRLF;
      i:=i+n-1;
    end;
  end else begin
    k:=(a.Count)/n;
    for i:=0 to k-1 do begin
      for j:=0 to n-1 do begin
        if((i+j*k)<a.Count-1) then begin
          s:=s+IntToStr(i+j*k+1)+'. '+a[i+j*k];
          if(j<n-1) then s:=s+OUTTXT_SEPARATOR;
        end;
      end;
      s:=s+CRLF;
    end;
  end;
  s1:=RelToAbsFilename(OUTTXT_FILE,GetCwgDir());
  StringToFile(s,s1);
  if(not bSilent) then ShowMessage('Seznam uloen do souboru:'+CRLF+CRLF+s1);
  if(a<>nil) then a.Free();
end;

procedure ExportGpxPoi(bSilent:boolean);
var a:TStringList;
    s,s1,sOut,ver:string;
    x,y:extended;
    i,j,n:Integer;
begin
  s1:=UpperCase(OUTPOI_SPLITCHARS);
  if(not RefPointGet(OUTPOI_REFPOINT,x,y)) then begin y:=14.0; x:=50.0; end;
  a:=GetExportData(false,false,OUTPOI_OUTCODING,'NAME'); //bez Sigitem, bez ID kese, v potrebnem kodovani
  n:=0;
  s:='';
  sOut:='';
  ver:=''; //prvni ulozeny znak
  for i:=0 to a.Count do begin
    if(i<a.Count) then begin
      j:=pos(UpperCase(copy(a[i],1,1)),s1);
      if(j>0) then begin
        s1:=ReplaceString(s1,copy(s1,j,1),''); //vymazeme znak, aby se na nem uz nedelil do dalsiho WPT
      end;
    end
    else j:=-1;
    if(i=a.Count) or (j>0) then begin
      if(s<>'') then begin //pridame zacatek a konec wpt a ulozime do Result
        sOut:=sOut
          + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
            +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
          +'  <name>'+CDATA(OUTPOI_NAME+' '+copy(ver,1,1)+'-'+copy(ver,2,1))+'</name>'+CRLF
          +'  <cmt></cmt>'+CRLF
          +'  <desc><![CDATA['+s+']]></desc>'+CRLF
          +'</wpt>'+CRLF
        ver:='';
        s:='';
      end;
    end;
    if(i<a.Count) then begin
      //zapamatujeme si prvni a posledni pocatecni znak jmena CWG v tomto WPT
      ver:=copy(ver,1,1)+UpperCase(copy(a[i],1,1));
      //prkodujeme nebezpecne znaky a zapiseme do vystupu
      s:=s+IntToStr(i+1)+'. '+XMLEntityEncode(a[i])+'<br />'+CRLF;
    end;
  end;
  sOut:='<?xml version="1.0" encoding="utf-8" standalone="no" ?>'+CRLF
    +'<gpx '+CRLF
    +'  creator="'+GeoGet_Version+', CwgList2 '+GetCurrentPluginVersion()+'"'+CRLF
    +'  version="1.1"'+CRLF
    +'  xmlns="http://www.topografix.com/GPX/1/1"'+CRLF
    +'  xmlns:gpxx="http://www.garmin.com/xmlschemas/GpxExtensions/v3"'+CRLF
    +'  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+CRLF
    +'  xsi:schemaLocation="http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">'
    +CRLF+CRLF+sOut+
{
      + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
      +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
      +'  <name>'+CDATA(POI_NAME)+'</name>'+CRLF
      +'  <cmt></cmt>'+CRLF
      +'  <desc>'+CDATA(s)+'</desc>'+CRLF
      +'</wpt>'+CRLF
}
    +CRLF
    +'</gpx>'+CRLF;
  s1:=RelToAbsFilename(OUTPOI_FILE,GetCwgDir());
  StringToFile(sOut,s1);
  if(not bSilent) then ShowMessage('Seznam uloen do souboru:'+CRLF+CRLF+s1);
  if(a<>nil) then a.Free();
end;

//------------------------------------------------------------------------------
procedure ExportGpx(bSilent:boolean);
//var a:TStringList;
//    i:Integer;
begin
end;
//------------------------------------------------------------------------------
function ExportGgstatHeader:string; //vytvori hlavicku tabulky
begin
  Result:='';
end;
//------------------------------------------------------------------------------
function RemoveXChars(s:string):string;
begin   //odstranime nebezpecne znaky
  Result:=RegexReplace('(?is)[ ;:/|''+#$%@&*]',s,'',false);
end;
//------------------------------------------------------------------------------
function GetTableCfg(param,sTabGroup:string):string; //vraci ze stringu cast konfigurace platnou pro tuto tabulku
var sType,sTable,s:string;
begin
  //vstupni string se predpoklada ve tvaru 'GRP1:text|GRP2:text...' nebo 'text'
  //vraci se text platny pro vstupni skupinu
  sTable:=UpperCase(RemoveXChars(UtfToAscii(AnsiToUtf(sTabGroup))));
  while(param<>'') do begin
    Result:=Fetch(param,'|'); //podle jednotlivych tabulek
    sType:=Fetch(Result,':'); //jmeno skupiny
    if(Result='') then begin Result:=sType; sType:=''; end;
    sType:=UpperCase(RemoveXChars(UtfToAscii(AnsiToUtf(sType))));
    if(sTable=sType) or ((sTable='ALL') and (sType='')) then s:='' //nalezeno, dal nehledame
    else Result:='';
  end;
end;
//------------------------------------------------------------------------------
function MakeIdCard(IdTable:string;iNumCwg:Integer):string;
begin
  Result:='iCard_'+IdTable+'_';
  //-1 znamena, ze ne[pridavame cislo
  if(iNumCwg>-1) then Result:=Result+IntToStr(iNumCwg);
end;
//------------------------------------------------------------------------------
function ExportGgstatSortButton(sIdTable,sTitle:string;idx:integer):string;  //vytvori tlacitko na zmenu razeni CWG
begin
  Result:='<span id="iCwgBut_'+sIdTable+'_'+IntToStr(idx)
    +'" style="'+OUTHTML_CSS_BUTTON+'"'
    +' onmousedown="sortCwg('+IntToStr(idx)+','''+sIdTable+''''
    +',aCwg_'+sIdTable+');">'+sTitle+'</span>';
end;
//------------------------------------------------------------------------------
function ExportGgstatSortButtons(list:TStringList;sIdTable,sObsah:string):string;  //vytvori talcika na zmenu razeni CWG
var idx,nItems:Integer;
    s:string;
begin
  // napred vypiseme seznam vsech CWG a jejich prvku tak, aby byly pouzitelne pro
  // razeni pres Javascript
  Result:='<script type="text/javascript">'+CRLF
         +'  aCwg_'+sIdTable+'=Array();'+CRLF
         +'  aCwgItems_'+sIdTable+'=Array();'+CRLF
         +'  nCwg_'+sIdTable+'='+IntToStr(list.Count/CWG_PROPERTIES)+';'+CRLF
         +'  nButtons=4;'+CRLF
        // vytvorime pole se spravnym poradim indexu polozek na karte
         +'  aCwgItems_'+sIdTable+'[0]=1;'+CRLF  //index polozky Nick
         +'  aCwgItems_'+sIdTable+'[1]=2;'+CRLF  //index polozky GC kese
         +'  aCwgItems_'+sIdTable+'[2]=3;'+CRLF  //index polozky katalogoveho cisla CWG (napr. cle00058a)
         +'  aCwgItems_'+sIdTable+'[3]=4;'+CRLF  //index polozky datum ziskani
         ;
  //vypiseme pole se vsemi prvky pro manipulaci s kartami CWG
  //   0 ... ASCII nick
  //   1 ... GC kod kese
  //   2 ... ID CWG (napr. cle00058a)
  //   3 ... datum ziskani ve tvaru RRMMDD
  //   4 ... cely obsah karty ve tvaru HTML textu
  nItems:=5; // pole aCwg obsahuje pro kazde CWG 5 polozek, vsechny budou na jedinem radku
  for idx:=0 to list.Count-1 do begin
    //Result:=Result+'  aCwg_'+sIdTable+'['+IntToStr(idx)+']='''+ReplaceString(list[idx],'''','`')+'''; ';
    Result:=Result+'  aCwg_'+sIdTable+'['+IntToStr(idx)+']='''+list[idx]+'''; ';
    if(((idx+1) mod nItems)=0) then Result:=Result+CRLF;
  end;
  //ted pridame tlacitka do HTML
  Result:=Result+'</script>'+CRLF+CRLF
    +'<p style="text-align:center; margin-bottom:25px;">'+CRLF;
  while(sObsah<>'') do begin
    s:=Fetch(sObsah,',');
    if(s='NAME') then Result:=Result+ExportGgStatSortButton(sIdTable,UtfToCharset(AnsiToUtf('Jmno CWG'),OUTHTML_OUTCODING),0);
    if(s='CACHE') then Result:=Result+ExportGgStatSortButton(sIdTable,UtfToCharset(AnsiToUtf('ID kee'),OUTHTML_OUTCODING),1);
    if(s='IMG') then Result:=Result+ExportGgStatSortButton(sIdTable,UtfToCharset(AnsiToUtf('Katalogov slo'),OUTHTML_OUTCODING),2);
    if(s='DATE') then Result:=Result+ExportGgStatSortButton(sIdTable,UtfToCharset(AnsiToUtf('Datum'),OUTHTML_OUTCODING),3);
  end;
  Result:=Result+'</p>'+CRLF;
end;
//------------------------------------------------------------------------------
function MakeCardItem(sText,sTitle,sUrl:string):string; //zaznam jedne polozky karty s ohledem na URL a komentar
begin
  Result:='';
  if(sTitle<>'') then sTitle:=' title="'+sTitle+'" alt="'+sTitle+'"';
  if(sUrl<>'') then Result:='<a href="'+sUrl+'"'+sTitle+' target="CWG_url">'+sText+'</a>'
  else begin
    if(sTitle<>'') then Result:='<span'+sTitle
      //+' style="text-decoration:underline;">'
      +' style="border-bottom:dotted; border-bottom-width:thin; cursor:default;">'
      +sText+'</span>'
    else Result:=sText;
  end;
end;

//------------------------------------------------------------------------------
function MakeStringCard(sIdTable,sNumber,sObsah,sNick,sCache,sDate,sImg,sGuid,sCacheUrl,sIdCwg,
  sNickComment,sCacheComment,sImgComment,sDateComment:string):string;
var s:string;
begin
  Result:='';
  if(sImgComment<>'') then sIdCwg:=sImgComment;
  while(sObsah<>'') do begin
    s:=Fetch(sObsah,',');
    if(s='NAME') then Result:=Result+MakeCardItem(sNick,sNickComment,sGuid)+'<br />';//+CRLF
    if(s='CACHE') then Result:=Result+MakeCardItem(sCache,sCacheComment,sCacheUrl)+'<br />';//+CRLF
    if(s='IMG') then Result:=Result+MakeCardItem(
      '<img src="'+sImg+'" title="'+sIdCwg+'" alt="'+sIdCwg+'"'
      +' style="margin-top:5px; margin-bottom:5px; width:'+GetTableCfg(OUTHTML_CARD_IMGSIZE,sIdTable)
      +'; height:'+GetTableCfg(OUTHTML_CARD_IMGSIZE,sIdTable)+';" />'
      ,'','')+'<br />';//+CRLF
    if(s='DATE') then Result:=Result+MakeCardItem(sDate,sDateComment,'');//+CRLF
  end;
end;
//------------------------------------------------------------------------------
function MakeStringCardDiv(sIdtable,sNumber,obsah:string):string;
begin
  //nemuzeme pridavat CRLF, protoze je to ulozeno v Stringlistu, ktery by to povazoval za oddelovac polozek
  Result:='<div id="iCwg'+sIdTable+'_'+sNumber+'"'
    +' style="width:'+GetTableCfg(OUTHTML_CARD_WIDTH,sIdTable) +'; height:'+GetTableCfg(OUTHTML_CARD_HEIGHT,sIdTable)+';'
    +' overflow:hidden;'
    +' display:inline-block; text-align:center;'+GetTableCfg(OUTHTML_COLOR,sIdTable)+';'
    +'; vertical-align:bottom; margin-top:4px;'
    +' background-color:#'+GetTableCfg(OUTHTML_CARD_BGCOLOR,sIdTable)+';'
    +' border:'+GetTableCfg(OUTHTML_CARD_BORDER,sIdTable)+';">'//+CRLF
    +obsah
    +'</div>'//+CRLF
    ;
end;
//------------------------------------------------------------------------------
function ExportGgStatSortFunction:string;
begin   //odstranime nebezpecne znaky
  //vypsat funkci na zmenu razeni karet s CWG
  Result:='<script type="text/javascript">'+CRLF
         +'function sortCwg(sortIndex,idTable,aCwg){'+CRLF
         +'  var Elem,sId,i,j,idx,nItems;'+CRLF
         +'  var a=Array();'+CRLF
         +'  nItems=5; //5 prvku na jedno CWG (nameUpAscii, id kese, id cwg, datum, div pro zobrazeni'+CRLF
         +'  var nCwg=aCwg.length/nItems; //pocet prvku pole'+CRLF
         ///###+'  nItems='+IntToStr(nItems)+';'+CRLF
       //+'alert("Seradime CWG podle indexu "+sortIndex'+CRLF
       //+' +"\nidTable: "+idTable'+CRLF
       //+' +"\nnItems: "+nItems'+CRLF
       //+' +"\nnCwg: "+nCwg'+CRLF
       //+' );'+CRLF
       //+'alert("Obsah pole aCwg:"'+CRLF
       //+' +"\naCwg[0]="+aCwg[0]'+CRLF
       //+' +"\naCwg[1]="+aCwg[1]'+CRLF
       //+' +"\naCwg[2]="+aCwg[2]'+CRLF
       //+' +"\naCwg[3]="+aCwg[3]'+CRLF
       //+' +"\naCwg[4]="+aCwg[4]'+CRLF
       //+' +"\nnItems: "+nItems'+CRLF
       //+' +"\nnCwg: "+nCwg'+CRLF
       //+' );'+CRLF
         +'  //pole hodnot k serazeni (musime odlisit pripadne stejne texty, napr. "Vymena")'+CRLF
         +'  for(i=0;i<nCwg;i++){ '+CRLF
         //vzdy pridame jeste katalogove cislo, protoze treba datum muze byt spolecne vice CWG
         +'    a[i]=aCwg[i*nItems+sortIndex]+aCwg[i*nItems+2];'+CRLF
       //+'alert("Trideny prvek "+i+": "+aCwg[i*nItems+sortIndex]+"\n"+aCwg[i*nItems+nItems-1]);'+CRLF
         +'  }'+CRLF
         +'  a.sort();             //pole seradime'+CRLF
         +'  for(i=0;i<nCwg;i++){  //znovu naplnime vsechny prvky do karet s CWG'+CRLF
         +'    sId="iCwg"+idTable+"_"+(i+1);'+CRLF
         +'    Elem=document.getElementById(sId);'+CRLF
       //+'alert("i="+i+", sId="+sId+", Elem="+Elem);'+CRLF
         +'    if(!Elem) continue;'+CRLF
         +'    for(j=0;j<nCwg;j++){'+CRLF
         +'      if(a[i]==aCwg[j*nItems+sortIndex]+aCwg[j*nItems+2]){ //vypsat prvky na karte'+CRLF
       //+'alert("---obsah karty: "+a[i]+"\n"+aCwg[j*(nItems+1)-1]);'+CRLF
         +'        Elem.innerHTML=aCwg[j*nItems+nItems-1];'+CRLF
         +'      }'+CRLF
         +'    }'+CRLF
         +'  }'+CRLF
         +'  //zmenime styl ramecku tlacitek'+CRLF
         +'  for(i=0;i<nButtons;i++){'+CRLF
         +'    sId="iCwgBut_"+idTable+"_"+i;'+CRLF
         +'    Elem=document.getElementById(sId);'+CRLF
         //+'    alert("i="+i+", sortIndex="+sortIndex+", Elem="+Elem);'+CRLF
         +'    if(Elem){'+CRLF
         +'      if(sortIndex==i) Elem.style.borderStyle="inset";'+CRLF
         +'      else Elem.style.borderStyle="outset";'+CRLF
         +'    }'+CRLF
         +'  }'+CRLF
         +'}'+CRLF
         +'</script>'+CRLF+CRLF;
end;
//------------------------------------------------------------------------------
function GgstatTable(sTabGroup,sNameTable,sColor,sColorBg,sWidthTable:string):string;
var a:TStringList;
    s,sType,sNick,sJpg,sDate,sCategory,sCache,sCacheUrl,sCacheComment,sIdCwg,sGuid:string;
    sObsah:string;
    tab:TSQLiteTable;
    i,n:Integer;
begin
  //napred zjistime obsah karty, abychom mohli dat jen pozadovana tlacitka, ...
  sObsah:=GetTableCfg(OUTHTML_CARD_CONTENT,sTabGroup);
  if(sObsah='') then sObsah:='IMG,CACHE,DATE,NAME';
  sObsah:=UpperCase(sObsah);
  //ShowMessage('SSSSS seznam prvku na karte pro tabulku '+sTabGroup+': '+sObsah);

  sType:=OUTHTML_TYPES;
  sType:=ReplaceString(sType,',',''',''');
  sType:=''''+sType+'''';
  a:=TStringList.Create();
  // Nick, <UrlNick>, DateSort, DateText, id_cwg, <img>, ID_kese, url_kese
  s:='SELECT NameUpAscii, Name, CacheId, DateFound, Category, Version, Id, Img, GUID'
    +', CommentName, CommentCacheId, CommentImg, CommentDate '+CRLF
    +' FROM '+TABLE_FOUND+' my '+CRLF
    +' WHERE my.Category<>'''+AnsiToUtf(MY_CATEGORY)+''''+CRLF
    +' and my.Category IN ('+sType+')'+CRLF;
  //pokud je pozadovana nejaka skupina, vybereme jeste skupinu CWG
  if((sTabGroup<>'') and (sTabGroup<>'ALL')) then s:=s+' and my.TabGroup='''+AnsiToUtf(sTabGroup)+''''+CRLF;
  //nastavime pozadovane implicitni razeni
  if(OUTHTML_SORT_DEFAULT='DATE') then s:=s+' order by my.DateFound'
  else if(OUTHTML_SORT_DEFAULT='CACHE') then s:=s+' order by my.CacheId'
  else s:=s+' order by my.Name';
  //vypustime nebezpecne znaky
  sTabGroup:=ReplaceString(sTabGroup,' ','');
  sTabGroup:=ReplaceString(sTabGroup,'''','');
  sTabGroup:=ReplaceString(sTabGroup,'"','');
  DBOpen();
  Tab:=CwgDB.GetTable(s,false);
  n:=0;
  try
    while not Tab.eof do begin
      Inc(n);
      a.Add(ReplaceString(Tab.FieldAsString(0),'''','`')); //   0 ... ASCII nick
      //a.Add(Tab.FieldAsString(0)); //   0 ... ASCII nick
      sNick:=ReplaceString(Tab.FieldAsString(1),'''','`');  //         Nick
      sCache:=Tab.FieldAsString(2);
      sCategory:=Tab.FieldAsString(4);
      sCacheUrl:='http://www.geocaching.com/seek/cache_details.aspx?wp='+sCache;
      if(not IsValidGC(sCache)) then sCacheUrl:='';
      a.Add(sCache);               //   1 ... GC kod kese
      i:=Tab.FieldAsInteger(6);
      if(i>0) then sIdCwg:=Tab.FieldAsString(4)+FormatFloat('00000',i)
        +VerToShortSuffix(Tab.FieldAsInteger(5))
      else sIdCwg:=sCategory+'-???';
      a.Add(sIdCwg); //   2 ... ID CWG (napr. cle00058a)
      sDate:=Tab.FieldAsString(3); //   datum ziskani, pokud je jine nez datum nalezu
      if(sDate='') then begin  //musime najit datum nalezu kese
        sDate:=Geoget_DB.GetTableString('SELECT dtfound from geocache where id='''+sCache+'''');
      end;
      a.Add(sDate);            //   3 ... datum ziskani ve tvaru RRRRMMDD, pro razeni
      sDate:=copy(sDate,7,2)+'.'+copy(sDate,5,2)+'.'+copy(sDate,1,4); //prevedeme na lidsky format
      sJpg:=Tab.FieldAsString(7);
      if(sJpg='') then sJpg:=CwgDB.GetTableString('SELECT jpg from '+TABLE_CATALOG+' where Category='''+sCategory+''' and id='+IntToStr(i)+' and version='+Tab.FieldAsString(5));
      if(sJpg='') then sJpg:=OUTHTML_CARD_URLOUTOFCATALOG;
      sGuid:=Trim(Tab.FieldAsString(8));
      if(sGuid='') then sGuid:=CwgDB.GetTableString('SELECT UserGuid from '+TABLE_CATALOG+' where Category='''+sCategory+''' and id='+IntToStr(i)+' and version='+Tab.FieldAsString(5));
      sCacheComment:=Tab.FieldAsString(10);
      //pokud neni komentar, napisem tam jmeno keske
      if(sCacheComment='') then sCacheComment:=Geoget_DB.GetTableString('SELECT Name from geocache where id='''+sCache+'''');
      //naformatujeme string pro zobrazeni cele karty
      //!!! XMLEntityEncode pracuje v UTF !!!!
     s:=MakeStringCard(sNameTable,IntToStr(n),sObsah
        ,UtfToCharset(XMLEntityEncode(sNick),OUTHTML_OUTCODING)
        ,UtfToCharset(sCache,OUTHTML_OUTCODING)
        ,UtfToAnsi(sDate)               {Date v lidskem formatu}
        ,UtfToAnsi(sJpg)                {Img}
        ,UtfToAnsi(sGuid)               {GUID}
        ,UtfToAnsi(sCacheUrl)           {odkaz na listing kese}
        ,sIdCwg                         {kod CWG}
        ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(9)),OUTHTML_OUTCODING){NickComment}
        ,UtfToCharset(XMLEntityEncode(sCacheComment),OUTHTML_OUTCODING)       {CacheComment}
        ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(11)),OUTHTML_OUTCODING){ImgComment}
        ,UtfToCharset(XMLEntityEncode(Tab.FieldAsString(12)),OUTHTML_OUTCODING){DateComment}
        );
      a.Add(s); //   4 ... cely obsah karty ve tvaru HTML textu
      Tab.next();
    end;
  finally
    Tab.Free();
    DBClose();
  end;

  //pridame tlacitka a javascriptovou funkci pro zmenu razeni
  Result:='';
  if(GetTableCfg(OUTHTML_SORT,sTabGroup)='1') then Result:=Result+ExportGgstatSortButtons(a,sNameTable,sObsah)+CRLF;
  //vytvorime DIV pro karty s CWG
  Result:=Result+'<div style="width:'+sWidthTable+'; ';
  s:=trim(GetTableCfg(OUTHTML_HEIGHT,sTabGroup));
  if(s<>'') then Result:=Result+' height:'+s+'; overflow:auto;';
  Result:=Result+' font-size:'+GetTableCfg(OUTHTML_FONTSIZE,sTabGroup)+';'
    +' display:inline-block; margin-bottom: 20px; text-align:center; ';
  s:=trim(GetTableCfg(OUTHTML_COLOR,sTabGroup));
  if(s<>'') then Result:=Result+' color:'+s+';';
  s:=trim(GetTableCfg(OUTHTML_COLOR_BG,sTabGroup));
  if(s<>'') then Result:=Result+' background-color:#'+s+';';
  Result:=Result+'">'+CRLF;

  //pridame vsechny karty
  n:=1;
  for i:=0 to a.Count-1 do begin
    Result:=Result
      +MakeStringCardDiv(sNameTable,IntToStr(n),a[i+4])+CRLF;
    i:=i+4;
    n:=n+1;
  end;

  //sOut:=sOut+ExportGgstatSortButtons(a,sIdTable)+CRLF;
  //nastavime spravne vystupni kodovani
  Result:=Result+'<br /><br /><a href="http://geoget.ararat.cz/doku.php/user:skript:cwglist2">CwgList '+GetCurrentPluginVersion()+'</a><br />';
  Result:=Result+'</div>'+CRLF;
  if(a<>nil) then a.Free();
end;
//------------------------------------------------------------------------------
procedure ExportGgstat(sTabGroup:string;bSilent:boolean);
var sTabGroups,sColor,sColorBg,sOutcoding,sWidth:string;
    aBarvy:TypeGgStatColors;
    s,sOut,sFileTemplate,sGrp,sName:string;
begin
  ShowMessage('WARN: Export pro GgStat neni dale udrzovan.'+CRLF+CRLF
    +'Format exportu neni vhodny pro Stator a mimo jine'+CRLF
    +'nepodporuje vsechny kategorie CWG evidovane v katalogu.'+CRLF
    );
  sTabGroups:=Trim(OUTHTML_GRP);
  sColor:=Trim(OUTHTML_COLOR);
  sColorBg:=Trim(OUTHTML_COLOR_BG);
  sOutcoding:=OUTHTML_OUTCODING;
  sWidth:=ReplaceString(OUTHTML_WIDTH,'px','');
  //ziskame hodnoty z Template souboru, pokud jsou potreba
  sFileTemplate:=RelToAbsFilename(OUTHTML_GGSTATTEMPLATE,GetCwgDir());
  if(GgStatGetColors(sFileTemplate,1,aBarvy)=false) then begin
    ShowMessage('ERR: chyba cteni Template souboru: '+CRLF+CRLF+sFileTemplate);
    exit;
  end;
  if(sColor='') then sColor:=aBarvy[GGSTAT_COLOR_TEXT];
  if(sColorBg='') then sColorBg:=aBarvy[GGSTAT_COLOR_BG];
  if(sOutcoding='') then GgStatGetCommand(sFileTemplate,'OUTCODING',1,sOutcoding);

  GgStatGetCommand(sFileTemplate,'WIDTH',1,s);
  if(sWidth='') then sWidth:=IntToStr(StrToInt(s)-30); //sirka tabulky je
  sWidth:=sWidth+'px';
  {
  s:='UUUUU nacteno z Template:'+CRLF
    +'sWidth: '+sWidth+CRLF
    +'sColor: '+sColor+CRLF
    +'sColorBg: '+sColorBg+CRLF
    +'sOutcoding: '+sOutcoding+CRLF
    ;
  for i:=0 to GGSTAT_COLORS-1 do begin
    s:=s+IntToStr(i)+'. '+aBarvy[i]+CRLF;
  end;
  ShowMessage(s);
  }
  if(sTabGroups='') then sTabGroups:='ALL';
  sOut:='';
  while(sTabGroups<>'') do begin
    sGrp:=Fetch(sTabGroups,'|');
    //jmeno tabulky a pole ...
    sName:=RemoveXChars(UtfToAscii(AnsiToUtf(sGrp)));
    sName:=ReplaceString(sName,'\','');
    //ShowMessage('PPPPP sGrp='+sGrp+', sName='+sName);
    if((sOut='') and (OUTHTML_SORT='1')) then sOut:=sOut+ExportGgStatSortFunction()+CRLF+CRLF;
    sOut:=sOut+GgStatTable(sGrp,sName,sColor,sColorBG,sWidth);
    s:=RelToAbsFilename(OUTHTML_FILE,GetCwgDir());
    if(sName='ALL') then sName:='';
    s:=ReplaceString(s,'%GRP%',sName); //pojmenovat spravne vystupni soubor
    StringToFile(sOut,s);
    if(not bSilent) then ShowMessage('Seznam uloen do souboru:'+CRLF+CRLF+s);
    sOut:=CRLF;  //aby nebyl prazdny string a znovu se neexportovala funkce
                 //javascriptu po razeni CWG podle
  end;
end;

