{
  obsluha weboveho serveru cwg.gcm.cz (niximor)
  popis API: http://cwg.gcm.cz/apitest/cwgapi.html
}

//protoze cteni katalogu vypadava na timeout, zatim pro ladeni
//nacitani preskakuji a pracuji s drive ulozenym souborem
{ $define READ_GCM_CATALOG}

var sSession:string;

function IsTestCwgDb(bShowMessage:boolean):boolean;
begin
  Result:=true;
  if(pos('\CWGList.db3',GetDbPathname())<1) and (Uppercase(GEOGET_OWNER)='GORDICI') then begin
    //if(bShowMessage) then ShowMessage('ERR: funkci lze pustit jen pri praci s databazi "CWGList_test.db3"');
    Result:=false;
  end;
end;

function GGDateToGcmDate(date:string):string;
begin Result:=copy(date,1,4)+'-'+copy(date,5,2)+'-'+copy(date,7,2); end;

function GcmDateToGGdate(date:string):string;
begin Result:=ReplaceString(date,'-',''); end;

function GetXmlFilename(cmd:string):string;
begin
  Result:=GetCwgDir()+'Download';
  ForceDirectories(Result);
  Result:=Result+'\gcm.'+cmd;
  if(cmd='ERROR') then Result:=Result+'.txt'
  else Result:=Result+'.xml';
end;

//--- vyhodnoti, zda v XML souboru s odpovedi neni nejaka chyba
function GcmIsOk(sFile:string):boolean;
var ele: TJclSimpleXMLElem;
    Xml:TJclSimpleXML;
    i:integer;
    s:string;
begin
  Result:=false;
  s:=FileToString(sFile);
  if(s[1]<>'<') then begin
    ShowMessage('ERR: chybny format odovedi z GCM, neni XML:'+CRLF+'  '+sFile);
    exit;
  end;
  Xml:=TJclSimpleXML.Create();
  try
    Xml.loadfromfile(sFile,seUTF8,0);
    i:=0;
    ele:=XML.Root.Items[i];
    while (ele.name='') do begin //preskaceme vsechny komentare
      Inc(i);
      ele:=XML.Root.Items[i];
    end;
    if(ele.name='Success') then begin   //divna struktura, neobsahuje potvrzeni
      if(ele.value='true') then begin //vse OK, ukoncime se
        Result:=true;
        if(Xml<>nil) then Xml.Free();
        exit;
      end;
      //chybu vypiseme
      Inc(i);
      ele:=XML.Root.Items[i];
      //while (ele.name='') do begin //preskaceme vsechny komentare
      //end;
{$ifdef DEBUG_HELPER} LDH('GcmIsOk(): tag s chybou: <'+ele.name+'>');{$endif}
      CwgForm.Visible:=true;
      if(ele.name='Error') then begin
        StringToFile('ERR: chyba zpracovani pozadavku na GCM: '+CRLF+'  '+sFile
          +CRLF+CRLF+ele.value,GetXmlFilename('ERROR'));
        RunShell(GetXmlFilename('ERROR'));
        //ShowMessage('ERR: chyba zpracovani pozadavku na GCM: '+CRLF+'  '+sFile);
      end
      else begin
        ShowMessage('ERR: nespecifikovana chyba zpracovani pozadavku na GCM'+CRLF+'  '+sFile);
      end;
      if(Xml<>nil) then Xml.Free();
      exit;
    end;
  finally
  end;
  Result:=true; //prvni tag jsou uz data
{$ifdef DEBUG_HELPER} LDH('GcmIsOk(): vracena odpoved ('+sFile+'): OK');{$endif}
  if(Xml<>nil) then Xml.Free();
end;

//--- predani prikazu na server a nacteni odpovedi
function GcmSendCommand(Cmd,Params,sUpload,sFile:string):boolean;
var sMethod,sUrl,sUploadType,s:string;
    //ini:TIniFile;
begin
  Result:=false;
  sUploadType:='';
  if(sUpload<>'') then sUploadType:='application/xml'; //data posilame v xml
  //sMethod:='GET';
  sMethod:='POST';
  sUrl:=GCM_SERVER+Cmd+'?'+Params;     //sestavime cele URL s prikazem
  //doplnime format
  if(Params<>'') then sUrl:=sUrl+'&';
  if(Cmd='login') then sUrl:=sUrl+'format=xml';
  if(Cmd='collection/export') then sUrl:=sUrl+'format=fullxml';
  if(Cmd='collection/import') then  sUrl:=sUrl+'format=xml&fileformat=fullxml';

{$ifdef DEBUG_HELPER} LDH('URL='+sUrl);{$endif}
  //pokud se nacita cely katalog, trva serveru hrozne dlouho nez posle prvni
  //byte odpovedi a pri standardnim timeoutu HttpAsk vypadne po minute
  //zkusime nastavit timeout na delsi v DATADIR\geoget.ini hodntota
  //httptimeout=180000 (ale musi se to udelat pred sopustenim GG!)
  if(not HttpAsk(sMethod, sUrl, sUploadType, sUpload, s)) then begin
{$ifdef DEBUG_HELPER} LDH('ERROR: HttpAsk: sMethod='+sMethod+', UploadType='+sUploadType+CRLF+'  ... odpoved s='+s); {$endif}
    ShowMessage('ERR: '+_('Cannot send command: ')+CRLF+sUrl);
    exit;
  end;
  StringToFile(s,sFile);
  if(s='') then Result:=false
  else begin
    if(Cmd='cwg/export') then Result:=true
    else Result:=GcmIsOk(sFile);
  end;
end;

//--- prihlaseni k serveru, ulozi session
function GcmLogin:boolean;
var j:Integer;
    sFile:string;
    ele: TJclSimpleXMLElem;
    Xml:TJclSimpleXML;
begin
  Result:=true;
{$ifdef DEBUG_HELPER} LDH('GcmLogin(): sSession='+sSession);{$endif}
  if(sSession<>'') then exit;   //jiz jsme prihlaseni
  sFile:=GetXmlFilename('login');
  //prekodujeme nick do tvaru pro URL (ovsem jak to ma byt s cestinou?
  //ma byt v utf? ted je v ansi)
  Result:=GcmSendCommand('login','username='+EncodeUrlElement(AnsiToUtf(GCM_USER))
    +'&password='+EncodeUrlElement(AnsiToUtf(GCM_PWD)),'',sFile);
  if(not Result) then exit;
  Xml:=TJclSimpleXML.Create();
  try
    Xml.loadfromfile(sFile,seUTF8,0);
    for j:=0 to XML.Root.Items.count-1 do begin
      ele:=XML.Root.Items[j];
      if(ele.name='Success') then Result:=(ele.Value='true');
      if(ele.name='Session') then sSession:=ele.Value;
    end;
  finally
  end;
  if(Xml<>nil) then Xml.Free();
  if(not Result) then begin
    sSession:='';
    ShowMessage('ERR: '+_('Cannot login to gcm server!'));
  end;
  //DeleteFile(sFile);
end;

function GcmGetStartXml:string;
begin
  Result:='<?xml version="1.0" encoding="utf-8"?>'+CRLF
    +'<cwgexport xmlns="http://cwg.gcm.cz" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://cwg.gcm.cz /cwgexport.xsd">'+CRLF
	  +'  <!-- Exported from '++' -->'+CRLF
	  +'  <user>'+GCM_USER+'</user>'+CRLF
	  +'  <profile>http://cwg.gcm.cz/users/index/'+GCM_USER+'</profile>'+CRLF
	  //+'  <cwg id="">'+CRLF //tady ma byt nejake interni ID
    ;
end;

function GcmMakeCatno(Cat:string;Id,Ver:Integer):string; //pokud je zaporne, nevytvari nic
begin
  Result:='';
  if(Id>0) then begin
    Result:='    <cat_no>'+Cat+IntToStrLength(Id,5);
    if(Ver>1) then Result:=Result+Chr(95+Ver);
    Result:=Result+'</cat_no>'+CRLF;
  end;
end;

function FindGcmItem(aData:TStrings;sItem:string):string;
var i:integer;
    s:string;
begin
  Result:='';
  for i:=0 to aData.Count-1 do begin
    s:=aData[i];
    Fetch(s,sItem+':');
    if(s<>'') then Result:=s;
  end;
end;

function GcmMakeCollection(aGcm:Tstrings;Name,date,CacheId,CommentName,CommentDate,CommentCacheId,CommentImg,Count,sYear:string):string; //pripavi vsechny <entry> pro dane CWG
var i:integer;
    sEntry,sEntDate,sEntYear,sEntComm,sEntPiec:string;
begin
  Result:='';
  i:=1;
{$ifdef DEBUG_HELPER}
  //LDH('GcmPrepareXml(): CWG="'+Name);
{$endif}
  while (i>0) do begin //zpracujeme vsechny vstupy
    sEntry:=''; sEntDate:=''; sEntYear:=''; sEntComm:=''; sEntPiec:='';
    sEntDate:=date;
    if(i>1) then sEntDate:=FindGcmItem(aGcm,'DATE_'+IntToStr(i)); //datum dalsiho nalezu
    if(sYear<>'') then sEntYear:=sYear                        //rok vyroby CWG
    else sEntYear:=FindGcmItem(aGcm,'YEAR_'+IntToStr(i));
    if(StrToInt(sEntYear)<2000) then sEntYear:=Copy(sEntDate,1,4); //pokud neni rok zarazeni, dame tam rok nalezu
{$ifdef DEBUG_HELPER}
      if(StrToInt(sEntYear)<2000) or (date='--') or (sEntDate='--') then begin //chybny rok
        LDH('GcmPrepareXml(): CWG="'+Name+'", sEntDate='+sEntDate+', sEntYear='+sEntYear);
      end;
{$endif}

    sEntPiec:=Count;
    if(i>1) then sEntPiec:=FindGcmItem(aGcm,'COUNT_'+IntToStr(i)); //pocet nalezenych kusu
    if(i=1) then begin
      if(CommentImg<>'') then sEntComm:=sEntComm+CommentImg+' | ';    //toto nedavame se jmenem, je to implicitni komentar
      if(CacheId<>'') then sEntComm:=sEntComm+'CACHE_ID: '+CacheId+' | ';
      if(CommentName<>'') then sEntComm:=sEntComm+'CMT_NAME: '+CommentName+' | ';
      if(CommentDate<>'') then sEntComm:=sEntComm+'CMT_DATE: '+CommentDate+' | ';
      if(CommentCacheId<>'') then sEntComm:=sEntComm+'CMT_CACHEID: '+CommentCacheId+' | ';
      sEntComm:=RegexReplace('[ |]*$',sEntComm,'',false); //odstranime koncovy oddelovac
    end
    else sEntComm:=FindGcmItem(aGcm,'COMMENT_'+IntToStr(i));
    if(sEntDate<>'') and (sEntYear<>'') and (sEntPiec<>'') then begin
      sEntry:='      <entry>'+CRLF
             +'        <date>'+sEntDate+'</date>'+CRLF
             +'        <year>'+sEntYear+'</year>'+CRLF
             +'        <pieces>'+sEntPiec+'</pieces>'+CRLF
             +'        <comment>'+sEntComm+'</comment>'+CRLF
             +'      </entry>'+CRLF;
      Result:=Result+sEntry;
    end;
    if(sEntDate='') and (sEntYear='') and (sEntPiec='') then begin
      i:=-2;
    end
    else begin
      i:=-2;
      if(sEntDate='') then sEntry:=sEntry+'date,';
      if(sEntYear='') then sEntry:=sEntry+'year,';
      if(sEntPiec='') then sEntry:=sEntry+'pieces,';
      sEntry:=RegexReplace(',$',sEntry,'',false); //smazeme koncovou carku
{$ifdef DEBUG_HELPER}
      if(length(sEntry)<16) then //pokud je vse prazdne, neni to chyba, ale konec
        LDHD('GcmPrepareXml(): pro CWG="'+Name+'" chybi povinna polozka: '+sEntry,ldhWarning);
{$endif}
    end;
    i:=i+1;
  end;
  if(Result<>'') then Result:='    <collection>'+CRLF+Result+'    </collection>'+CRLF;
end;

function GcmMakeWants(aGcm:Tstrings):string;
begin
  Result:='';
  if(FindGcmItem(aGcm,'WANTS')='YES') then Result:='    <wants />'+CRLF;
end;

function GcmMakeNotWant(aGcm:Tstrings):string;
begin
  Result:='';
  if(FindGcmItem(aGcm,'NOTWANT')='YES') then Result:='    <notwant />'+CRLF;
end;

function GcmMakeOffers(aGcm:Tstrings):string;
var s,s1:string;
begin
  Result:='';
  s1:='';
  s:=FindGcmItem(aGcm,'OFFERS_COUNT');
  if(s<>'') then s1:=s1+'      <pieces>'+s+'</pieces>'+CRLF;
  s:=FindGcmItem(aGcm,'OFFERS_COMMENT');
  if(s<>'') then s1:=s1+'      <comment>'+s+'</comment>'+CRLF;
  if(s1<>'') then Result:='    <offers>'+CRLF+s1+'    </offers>'+CRLF;
end;

function GcmPrepareXml(iStart,iKrok,nMax:Integer):string; //pripravi data vsech nasich CWG do XML formatu pro predani na gcm.cz
var tab:TSqliteTable;
    aGcm:TStrings;
    i:integer;
    sCat,sVer,sId,sCatNo,sYear:string;
begin
{$ifdef DEBUG_HELPER} LDH('GcmPrepareXml(): start iCwg='+IntToStr(iStart));{$endif}
  Result:='';
  tab:=CwgDB.GetTable(
         'SELECT f.Category,f.Id,f.Version,f.Name,f.Cnt,f.DateFound,f.CacheId,'
         +'f.CommentName,f.CommentDate,f.CommentCacheId,f.CommentImg,f.GcmData,c.Zarazeno '
         +'FROM '+TABLE_FOUND+' f, '+TABLE_CATALOG+' c '
         +'WHERE f.Category<>'''+AnsiToUtf(MY_CATEGORY)+''''
         +'  AND f.Id=c.Id AND f.Category=c.Category AND f.Version=c.Version '
         +'ORDER BY f.Name',false);
  try
    i:=0;
    while(not tab.Eof) do begin //pro kazde CWG vytvorime zaznam v XML
      if(i>=(iStart+iKrok)) then break;
      if(i>=iStart) then begin
        GeoBusyProgress(i,nMax);
        sCat:=tab.FieldAsString(0);
        sId:=tab.FieldAsString(1);
        sVer:=tab.FieldAsString(2);
        //zjistime rok vydani
        CwgDB.AddParamInt(':id',StrToInt(sId));
        CwgDB.AddParamInt(':ver',StrToInt(sVer));
        CwgDB.AddParamText(':cat',sCat);
        sYear:=Copy(tab.FieldAsString(12),1,4);
        //separujeme GcmData, kazda hodnota do jednoho radku
        aGcm:=StrToStrings(tab.FieldAsString(11),' | ');
        sCatNo:=GcmMakeCatno(sCat,StrToInt(sId),StrToInt(sVer));
        //nebudeme uvadet hodnotu tagu <image>, do <collection> musime dat nase
        //poznamky a datum nalezu
        Result:=Result
  	      +'  <cwg> <!-- poradi zpracovaneho CWG: '+IntToStr(i+1)+' -->'+CRLF
          +sCatno
          +'    <name>'+XMLEntityEncode(tab.FieldAsString(3))+'</name>'+CRLF
          //+'    <category>'++'</category>'+CRLF
          +'    <version>'+tab.FieldAsString(2)+'</version>'+CRLF
          //+'    <image></image>'+CRLF
          ;
        Result:=Result
          +GcmMakeCollection(
            aGcm,                          //hodnoty prevzate z GCM, ktere nejsou v databazi samostatne
            sCat+sId+'-'+sVer+','+tab.FieldAsString(3),//jmeno CWG, pouzito jen pro vypis
            GGDateToGcmDate(tab.FieldAsString(5)),     //datum nalezu
            tab.FieldAsString(6),                      //CacheId
            XMLEntityEncode(tab.FieldAsString(7)),     //CommentName
            XMLEntityEncode(tab.FieldAsString(8)),     //CommentDate
            XMLEntityEncode(tab.FieldAsString(9)),     //CommentCacheId
            XMLEntityEncode(tab.FieldAsString(10)),    //CommentImg
            XMLEntityEncode(tab.FieldAsString(4)),     //pocet nalezu
            sYear                                      //rok zarazeni CWG do katalogu
            )
          +GcmMakeOffers(aGcm)
          +GcmMakeWants(aGcm)
          +GcmMakeNotwant(aGcm)
          +'  </cwg>'+CRLF
          ;
        if(aGcm<>nil) then aGcm.Free();
        aGcm:=nil;
      end;
      tab.Next();
      i:=i+1;
    end;
  finally
  end;
  if(tab<>nil) then tab.Free();
  if(aGcm<>nil) then aGcm.Free();
  if(Result<>'') then Result:=GcmGetStartXml()+Result+'</cwgexport>'+CRLF;
{$ifdef DEBUG_HELPER} LDH('GcmPrepareXml(): stop');{$endif}
end;

procedure GcmAddFound(bPrepsat:boolean;sId,sVer,sCat,sName,sDate,sComment,sImg,sGcmData:string;iKs:integer);
var s,sNameUp:string;
begin
  //pokud je to CWG mimo katalog, napred urcime jeho ID a kategorii podle NameUpAscii
  if(sId='') or (sCat='') then begin
    sCat:='CWG';
    //napred zjistime podle NameUpAscii, zda tam CWG jiz nemame
    sNameUp:=AnsiToUpAscii(sName)+sVer;
    CwgDB.AddParamText(':cat',sCat);
    CwgDB.AddParamText(':nameUp',sNameUp);
    s:=CwgDB.GetTableString('SELECT Name FROM '+TABLE_FOUND+' WHERE NameUpAscii=:nameUp AND Category=:cat');
    if(s<>'') then begin//zjistime ID
      CwgDB.AddParamText(':cat',sCat);
      CwgDB.AddParamText(':nameUp',sNameUp);
      sId:=CwgDB.GetTableString('SELECT Id FROM '+TABLE_FOUND+' WHERE NameUpAscii=:nameUp AND Category=:cat');
    end
    else sId:=(IntToStr(UpdateLastId(true)));
  end;
  sNameUp:=AnsiToUpAscii(sName)+sVer;
  //zjistime, zda uz je CWG v databazi ziskanych
  CwgDB.AddParamInt(':Id',StrToInt(sId));
  CwgDB.AddParamText(':cat',sCat);
  CwgDB.AddParamInt(':ver',ShortSuffixToVer(sVer));
  s:=CwgDB.GetTableString('SELECT Name FROM '+TABLE_FOUND
      +' WHERE Id=:Id AND Version=:ver AND Category=:cat');
//{$ifdef DEBUG_HELPER} LDH('GcmAddFound(): s='+s+', sName='+sName+', sId='+sId+', sVer='+sVer+' ('+IntToStr(ShortSuffixToVer(sVer))+'), sCat='+sCat+', bPrepsat='+intToStr(bPrepsat as integer));{$endif}
  if(s<>'') and (not bPrepsat) then exit; //pokud existuje a nema se prepisovat, rovnou konec
  CwgDB.AddParamInt(':id',StrToInt(sId));
  CwgDB.AddParamInt(':ver',ShortSuffixToVer(sVer));
  CwgDB.AddParamText(':name',AnsiToUtf(sName));
{$ifdef DEBUG_HELPER}
  LDH('JJJJ jmeno v ANSI='+sName+', v UTF='+AnsiToUtf(sName)+' (toto jde do databaze)');
{$endif}
  CwgDB.AddParamText(':cat',sCat);
  CwgDB.AddParamText(':dat',sDate);
  CwgDB.AddParamInt(':isdat',2); //nedokazeme urcit, zda bylo nalezeno v kesi nebo ziskano jinak
  CwgDB.AddParamText(':cacheId','');
  CwgDB.AddParamInt(':cnt',iKs);
  if(sId<>'') then sImg:=''; //pokud je to katalagove CWG, ma katalogove IMG?
  //ale co s CWG, ktera jsou v katalogu, ja mam svuj obrazek, protoze v katalogu obrazek neni a treba nikdy nebude
  CwgDB.AddParamText(':img',sImg);
  CwgDB.AddParamText(':guid',''); //netusim, kde sebrat
  CwgDB.AddParamText(':comName','');
  CwgDB.AddParamText(':comId','');
  CwgDB.AddParamText(':comDate','');
  CwgDB.AddParamText(':comImg',AnsiToUtf(sComment));
  CwgDB.AddParamText(':group','');
  CwgDB.AddParamText(':nameUp',sNameUp);
  CwgDB.AddParamText(':gcm',AnsiToUtf(sGcmData));
  if(s='') then begin //SQL prikaz pro pridani
    CwgDB.ExecSQL('INSERT INTO '+TABLE_FOUND
      +' (NameUpAscii,    Name,  Id,  Category, Version, DateFound, Cnt,  CacheId,  Img,  GUID,  CommentName, CommentCacheId, CommentDate, CommentImg, TabGroup, IsCacheFound, GcmData) '
      +' VALUES (:nameUp, :name, :id, :cat,     :ver,    :dat,     :cnt, :cacheId, :img, :guid, :comName,    :comId,         :comDate,    :comImg,    :group,    :isdat,       :gcm)'
    );
  end
  else begin // SQL prikaz pro prepsani
    CwgDB.ExecSQL('UPDATE  '+TABLE_FOUND+' SET'
      +' NameUpAscii=:nameUp, Name=:name, Id=:id, Category=:cat, Version=:ver, DateFound=:dat,'
      +' Cnt=:cnt, CacheId=:cacheId, Img=:img,'
      +' GUID=:guid, CommentName=:comName, CommentCacheId=:comId, CommentDate=:comDate, CommentImg=:comImg,'
      +' TabGroup=:group, IsCacheFound=:isdat, GcmData=:gcm'
      +' WHERE Id=:id and Version=:ver and Category=:cat');
  end;
end;

function GcmImportXmlFile(sFile:string):boolean; //parsuje data a importuje do nasi databaze
var ele,eleCwg: TJclSimpleXMLElem;
    Xml:TJclSimpleXML;
    i,j,k,kk:integer;
    bPrepsat:boolean;
    sId,sVer,sCat,sName,sImg,sDate,sComment,sGcm,sIdGcm,sCatIdGcm,sVerGcm:string;
    iKs:integer;
begin
  Result:=true;
  j:=MessBox('Importem lze jen pidat nov CWG (CWG, kter v DB jsou, se nezmn)'+CRLF
            +'nebo importovanm souborem pepsat stvajc obsah.'+CRLF+CRLF
            +'Maj bt data pouze doplnna? (Ano=doplnit, Ne=pepsat, Storno=peruit)'+CRLF
            ,'Import dat na gcm.cz', 3 {tj. Ano/ne/cancel, odpoved 6=Ano, 7=ne});
  bPrepsat:=false;
  if(j=6) then bPrepsat:=false
  else begin
    if(j=7) then bPrepsat:=true
    else exit;
  end;
  DBOpen();
  Xml:=TJclSimpleXML.Create();
  try
    GeoBusyStart();
    GeoBusyCaption('Import kolekce z gcm.cz');
    GeoBusyKind('Parsovani ...');
    //sFile:='script\CwgList2\gcm-api\gcm.MimoKatalog.export.xml';
{$ifdef DEBUG_HELPER}
   LDHD('GcmPrepareXml(): '+sFile,ldhWarning);
{$endif}
    //0=CP_ACP, tj. ANSI. vystup z parsovani je tedy v kodovani ANSI
    //Xml.loadfromfile(sFile,seAuto,1250);
    //Xml.loadfromfile(sFile,seUTF8,1250);
    //Xml.loadfromfile(sFile,seAuto,0); //nespolehlive pro kratke soubory, radeji vynutime UTF8 kodovani
    Xml.loadfromfile(sFile,seUTF8,0);
    for j:=0 to XML.Root.Items.count-1 do begin
      GeoBusyProgress(j,XML.Root.Items.count);
      ele:=XML.Root.Items[j];
      case ele.name of
        //tohle by nemelo nastat, jak by se sem ta data dostala?
      'user': if(ele.Value<>GCM_USER) then begin //zkontrolujeme uzivatele
                ShowMessage('ERR: pokus o import dat jinho uivatele ne je nastaven v konfiguraci.'+CRLF+CRLF+ele.Value+' <> '+GCM_USER);
                break;
              end;
      'cwg':begin
              //vycistit hodnoty pro import
              sId:=''; sVer:=''; sCat:=''; sName:=''; sImg:=''; sDate:=''; sComment:='';
              sGcm:=''; iKs:=0; sIdGcm:=''; sVerGcm:='';
              //<cwg id=...> obsahuje interni id, bude se hodit pro CWG, ktera nejsou v katalogu
              sIdGcm:=Trim(ele.properties.ItemNamed['id'].Value);
              for i:=0 to ele.Items.count-1 do begin // vsechny elementy importovaneho CWG
                eleCwg:=ele.Items[i];
                case eleCwg.name of
                  'cat_no': begin  //parsovanim cisla katalogu zjistime id, verzi a kategorii, jak je to u CWG mimo katalog?
                              //odstranime cast '-[1-9]+', ktera neni u vsech a vlastne netusim, co znamena
                              sId:=eleCwg.Value;
                              eleCwg.Value:=Fetch(sId,'-');
                              sId:=RegexSubstitute('([0-9]+)',eleCwg.Value,'$1');
                              //od jiste doby neni verze v cat_no? pouzijeme tedy tu
                              //tu z version
                              sVer:=RegexSubstitute('[0-9]+([a-z]+)',eleCwg.Value,'$1');
                              sCat:=RegexSubstitute('^([a-zA-Z]+)',eleCwg.Value,'$1');
                            end;
                  'name': sName:=eleCwg.Value;
                  'category': begin //tohle je niximorova kategorie
                              sCatIdGcm:=Trim(ele.properties.ItemNamed['id'].Value);
                              sGcm:=sGcm+' | IDCAT_GCM:'+sCatIdGcm;
                            end;
                  'version': begin //tohle je niximorova verze
                              sVerGcm:=eleCwg.Value;
                              sGcm:=sGcm+' | VER_GCM:'+sVerGcm;

                            end;

                  'image': sImg:=eleCwg.Value; //ma vyznam jen u CWG mimo katalog
                  'offers': begin  //co nabizim k vymene
                              for k:=0 to eleCwg.Items.Count-1 do begin
                                case eleCwg.Items[k].name of
                                  'pieces': sGcm:=sGcm+' | OFFERS_COUNT: '+eleCwg.Items[k].value;
                                  'comment': sGcm:=sGcm+' | OFFERS_COMMENT: '+eleCwg.Items[k].value;
                                end;
                              end;
                             end;
                  'wants': sGcm:=sGcm+' | WANTS: YES';     //shanim ho
                  'notwant': sGcm:=sGcm+' | NOTWANT: YES';   //nechci ho
                  'collection': begin //pozor!!! <entry> muz byt vicekrat,
                                      //znamena to vice stejnych CWG s ruznou poznamkou, datem ...
                                      //vsechno z nadbytecnych <entry> pridame ke komentari
                  //{$ifdef DEBUG_HELPER} if(eleCwg.Items.Count<>1) then LDHD('GcmImportXmlFile(): CWG '+sId+' ('+sName+'), pocet <entry>='+IntToStr(eleCwg.Items.Count),LDH_dWarning);{$endif}
                                  for k:=0 to eleCwg.Items.Count-1 do begin
                                    if(eleCwg.Items[k].name='entry') then begin
                                      //with eleCwg.Items[k]
                                      for kk:=0 to eleCwg.Items[k].Items.Count-1 do begin
                                        case eleCwg.Items[k].Items[kk].name of
                                          'date': begin
                                                    if(k=0) then sDate:=GcmDateToGGDate(eleCwg.Items[k].Items[kk].Value)
                                                    else sGcm:=sGcm+' | DATE_'+IntToStr(k+1)+': '+GcmDateToGGDate(eleCwg.Items[k].Items[kk].Value);
                                                  end;
                                          'year': begin //rok vydani CWG (stejne CWG muze byt v jedine verzi, ale s ruznym rokem vyroby)
                                                    sGcm:=sGcm+' | YEAR_'+IntToStr(k+1)+': '+eleCwg.Items[k].Items[kk].Value;
                   //{$ifdef DEBUG_HELPER} if(eleCwg.Items.Count<>1) then LDHD('sGcm='+sGcm,LDH_dWarning);{$endif}
                                                  end;
                                          'comment':begin
                                                     //pro k=0 je potreba separovat jednotlive komentare podle priznaku, nechame to po celkovem nacteni CWG
                                                     if(k=0) then sComment:=eleCwg.Items[k].Items[kk].Value
                                                     else  sGcm:=sGcm+' | COMMENT_'+IntToStr(k+1)+': '+eleCwg.Items[k].Items[kk].Value;
                                                    end;
                                          'pieces': begin
                                                     //pocet kusu nemuzeme scitat, protoze pri vraceni zpet by bylo slozite ziska pocet prvniho nalezu
                                                     if(k=0) then iKs:=StrToInt(eleCwg.Items[k].Items[kk].Value)
                                                     else sGcm:=sGcm+' | COUNT_'+IntToStr(k+1)+': '+eleCwg.Items[k].Items[kk].Value;
                                                    end;
                                        end;
                                      end;
                                    end;
                                  end;
                                end;
                end;
              end;
              //pokud je na zacatku komentare ' | ', odstranime
              if(sIdGcm<>'') then sGcm:=sGcm+' | ID_GCM: '+sIdGcm;
              sGcm:=RegexReplace('^[ |]*',sGcm,'',false);
              //pokud neni sId a sVer, znamena to, ze CWG neni v katalogu,
              //v tom pripade neni cat_no, musime naplnit sVer
              if(sId='') or (sVer='') then begin
                sVer:=VerToShortSuffix(StrToInt(sVerGcm));
//{$ifdef DEBUG_HELPER} LDH('GcmPrepareXml(): sVerGcm='+sVerGcm+', sVer='+sVer);{$endif}
              end;
              //importujeme nactene hodnoty podle bPrepsat a existence CWG mezi nalezenymi
              //if(IsUtf(sName)) then sName:=UtfToAnsi(sName);
{$ifdef DEBUG_HELPER}
LDH('IIII Nacteno, pridavam CWG: '+sId+'='+sName+' (z parsovani), '
  +UtfToAnsi(sName)+' (po UtfToAnsi), '+AnsiToUtf(sName)+' (po AnsiToUtf) (vGcm='+sVerGcm+', moje='+sVer+')'
  );
{$endif}
              //if(IsUtf(sGcm)) then sGcm:=UtfToAnsi(sGcm);
              //if(IsUtf(sGcm)) then sComment:=UtfToAnsi(sComment);
{$ifdef DEBUG_HELPER}
//LDH('IIII Pridani CWG: '+sId+'='+sName+', (vGcm='+sVerGcm+', moje='+sVer+')');
{$endif}
              GcmAddFound(bPrepsat,sId,sVer,sCat,sName,sDate,sComment,sImg,sGcm,iKs);
            end;
      end;
      //if(ele.name='updated') then s:=s+'Aktualizovano '+ele.Value+' CWG'+CRLF;
      //if(ele.name='errors') then s:=s+'Chyba '+ele.Value+CRLF;
    end;
  finally
  end;
  if(Xml<>nil) then Xml.Free();
  DBClose();
end;

function GcmAllFromGcm:boolean; //funkce export z gcm importuje data do pluginu
var sFile:string;
begin
  if(not GcmLogin()) then exit;
  sFile:=GetXmlFilename('export');
  Result:=GcmSendCommand('collection/export','session='+sSession,'',sFile);
  if(not Result) then exit;
//    sFile:=GetCwgDir()+'gcm-api\cwgvalicek1.xml';
//{$ifdef DEBUG_HELPER}  LDHD('GcmAllFromGcm(): import testovaciho souboru: '+sFile,LDH_dWarning);{$endif}
  Result:=GcmImportXmlFile(sFile);
end;

function GcmAllToGcm:boolean; //funkce exportuje vsechna nase data na gcm.cz
var sFile,sXml,s,sErr,sOverwrite:string;
    i,j,iCwgKrok,nMax:Integer;
    iCwg,iProc,iAdd,iUpd,iSkip,iErr:integer;
    ele,eleErr: TJclSimpleXMLElem;
    Xml:TJclSimpleXML;
begin
  Result:=true;
{$ifdef DEBUG_HELPER} LDH('GcmAllToGcm(): start');{$endif}
  GeoBusyStart();
  if(not GcmLogin()) then begin
    CwgForm.Visible:=true;    //aby byl videt postup zpracovani
    exit;
  end;
  CwgForm.Visible:=false;    //aby byl videt postup zpracovani
  GeoBusyCaption('Export kolekce do gcm.cz');
  GeoBusyKind('Priprava dat ...');
  j:=MessBox('Data na serveru je mon jen doplnit o chybjc nebo kompletn pepsat.'+CRLF
             +'Maj bt pouze doplnna? (Ano=doplnit, Ne=pepsat, Storno=peruit)'+CRLF
             ,'Export dat na gcm.cz', 3 {tj. Ano/ne/cancel, odpoved 6=Ano, 7=ne});
  sOverwrite:='';
  if(j=6) then sOverwrite:='false';
  if(j=7) then sOverwrite:='true';
  if(sOverwrite='') then begin
    CwgForm.Visible:=true;    //aby byl videt postup zpracovani
    exit;
  end;
  //inicializovat sumy pro vysledky
  sErr:='';
  iErr:=0; iProc:=0; iAdd:=0; iUpd:=0; iSkip:=0; iErr:=0;
  //protoze import CWG serverem trva pomerne dlouho a GG ma nastaven limit
  //20 sekund na odpoved, zpracovavame po 100 CWG
  iCwg:=0;
  iCwgKrok:=100;
  sXml:='x';
  DBOpen();
  nMax:=CwgDB.GetTableValue('SELECT count(Id) from '
    +TABLE_FOUND+' WHERE Category<>'''+AnsiToUtf(MY_CATEGORY)+'''');
  while (sXml<>'') do begin //separovani po malem poctu CWG, aby to server zvladl zpracovat
{$ifdef DEBUG_HELPER} LDH('GcmAllToGcm(): zacatek zpracovani iCwg='+IntToStr(iCwg));{$endif}
    sXml:=GcmPrepareXml(iCwg,iCwgKrok,nMax);
    GeoBusyKind('Odeslam data na gcm ('+IntToStr(iCwg)+' - '+IntToStr(iCwg+iCwgKrok)+') ...');
    StringToFile(sXml,GetXmlFilename('import_send'));
    //CwgForm.Visible:=true; /////////////////////////////
    //exit;///////////////////////////////////////////////
    GeoBusyKind('ekm na vsledek ze serveru ...');
    if(sXml='') then begin
      //ShowMessage('ERR: prazdna data odesilana na gcm.cz');
      break;
    end;
    sFile:=GetXmlFilename('import');
    DeleteFile(sFile);
    if(not GcmSendCommand('collection/import','session='+sSession
      +'&overwrite='+sOverwrite,sXml,sFile)) then begin
      iErr:=-1;
      //ShowMessage('ERR: problem s odpoved z gcm.cz??? ('+sFile+')');
      break;
    end;
    //rozebereme vysledek
    GeoBusyKind('Zpracovn odpovdi ze serveru ...');
    Xml:=TJclSimpleXML.Create();
    try
      Xml.loadFromFile(sFile,seUTF8,0);
      s:='';
      for j:=0 to XML.Root.Items.count-1 do begin
        ele:=XML.Root.Items[j];
        if(ele.name='Processed') then iProc:=iProc+StrToInt(ele.Value);
        if(ele.name='Added') then iAdd:=iAdd+StrToInt(ele.Value);
        if(ele.name='Updated') then iUpd:=iUpd+StrToInt(ele.Value);
        if(ele.name='Skipped') then iSkip:=iSkip+StrToInt(ele.Value);
        if(ele.name='Errors') then begin
          for i:=0 to ele.Items.count-1 do begin
            eleErr:=ele.Items[i];
            if(eleErr.Name='item') then sErr:=sErr+Chr(9)+'- '+eleErr.Value+CRLF;
            Inc(iErr);
          end;
        end;
      end;
      iCwg:=iCwg+iCwgKrok;
    finally
    end;
    if(Xml<>nil) then Xml.Free();
    Xml:=nil;
  end; //zpracujeme dalsi krok
  s:='Zpracovano:'+Chr(9)+IntToStr(iProc)+' CWG'+CRLF
    +'Pridano:'+Chr(9)+Chr(9)+IntToStr(iAdd)+' CWG'+CRLF
    +'Aktualizovano:'+Chr(9)+IntToStr(iUpd)+' CWG'+CRLF
    +'Preskoceno:'+Chr(9)+IntToStr(iSkip)+' CWG'+CRLF
    +'Pocet chyb:'+Chr(9)+IntToStr(iErr)+CRLF;
  //zaporny pocet chyb znamena chybu dat poslanych na server (parsovani XML)
  //kladny pocet nezpracovanych CWG
  if(iErr>0) then begin
    sFile:=GetXmlFilename('ERROR');
    sErr:=s+CRLF+'Chyby:'+CRLF+sErr;
    StringToFile(sErr,sFile);
    s:=s+CRLF+'Prehled chyb je v souboru: '+sFile;
    RunShell(sFile);
  end;
  ShowMessage(s);
  CwgForm.Visible:=true;
  DBClose();
end;

function GcmReadCatalog:boolean;
var sFile,s,s1:string;
    sCountry,sOrigin,sType:string;
    n:integer;
    aList:TStringList;
    hFile:TFileStream;
    aCiselniky:TStringList;
begin
  Result:=true;
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): start'); {$endif}
  CwgForm.Cursor:=crHourglass;  //nastavit kurzor celemu formulari
  CwgForm_TabButtons.Cursor:=crHourglass;
  CwgForm_TabImport.Cursor:=crHourglass;
  CwgForm_butGcmKat.Cursor:=crHourglass;
  CwgForm.Visible:=false;
  GeoBusyStart();
  if(GcmLogin()) then begin
    aCiselniky:=TStringList.Create();
    try
      //ciselnik je serazeny a ignorujeme duplicity
      aCiselniky.Sorted:=true;
      //aCiselniky.CaseSensitive:=true;
      aCiselniky.Duplicates:=dupIgnore;
      //CwgForm.Visible:=false;    //aby byl videt postup zpracovani
      GeoBusyCaption('Import katalogu z gcm.cz');
      GeoBusyKind('Cteni dat ze serveru ...');
      sFile:=ReplaceString(GetXmlFilename('gcm-catalog'),'.xml','.csv');
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): cteni gcm=>sFile='+sFile); {$endif}
      DeleteFile(sFile);
      {$ifndef READ_GCM_CATALOG}
        ShowMessage('INFO: stahovani katalogu z gcm je potlaceno.'+CRLF
                    +'Pracuje se s drive ulozenym souborem katalogu.');
      {$else}
      //katalog je vracen v CSV formatu!
      if(not GcmSendCommand('cwg/export','session='+sSession,'',sFile)) then
        ShowMessage('ERR: problem s odpovedi z gcm.cz??? ('+sFile+')')
      else begin
        GeoBusyKind('Zpracovn odpovdi ze serveru ...');
      {$endif}
      //rozebereme vysledek, katalog je v UTF8, oddelovacem radku je jen LF
        //presuneme soubor do offline adresare
        s:=sFile;
        sFile:=GetOfflineDir()+'Cwg_GcmCatalog.csv';
        {$ifdef READ_GCM_CATALOG}
          RenameFile(s,sFile);
        {$endif}
        if(not FileExists(sFile)) then ShowMessage('ERR: Nenalezen soubor:'+CRLF+sFile)
        else begin
          GeoBusyKind('Parsovani nactenych dat ...');
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): otevreni streamu: '+sFile); {$endif}
          n:=0;
          hFile:=TFileStream.Create(sFile,fmOpenRead);
          try
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): cteni jednotlivych radku'); {$endif}
//http://stackoverflow.com/questions/11597634/read-line-with-tfilestream-delphi
            LibCsvInit(hFile);
            s:=LibCsvReadLine();
            while(s<>'') { and (n<20)} do begin
              Inc(n);
              if((n mod 100)=0) then
//{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): '+IntToStr(n)+'. radek katalogu: '+s); {$endif}
                GeoBusyProgress(hFile.Position,hFile.Size);
              ;
              aList:=LibCsvParseRow(s);
              //zkontrolujeme pocet polozek
              if(aList.Count<>15) then begin
                ShowMessage('ERR: Chybny pocet polozek v radku katalogu ('+IntToStr(aList.Count)+'<>'+'15), radek c. '+intToStr(n)+CRLF+CRLF+s);
                break;
              end;
              //ulozime do seznamu cislo kategorie, typ cwg, stat,
              aCiselniky.Add('cat:'+aList[2]);
              s:=aList[14];
              while(s<>'') do begin
                s1:=Fetch(s,':');
                case UpperCase(s1) of
                'COUNTRY': begin
                             sCountry:=Fetch(s,',');
                             aCiselniky.Add('country:'+sCountry);
                           end;
                'ORIGIN':  begin
                             sOrigin:=Fetch(s,',');
                             aCiselniky.Add('origin:'+sOrigin);
                           end;
                'TYPE':    begin
                             sType:=Fetch(s,',');
                             aCiselniky.Add('type:'+sType);
                           end;
                else begin
                             ShowMessage('ERR: neznama polozka v doplnujicich informacich o CWG'+CRLF
                             +'???='+s+CRLF);
                             aCiselniky.Add('unknown, ERR:'+sType);
                     end;
                end;
              end;
              //nacteme dalsi radek
              s:=LibCsvReadLine();
            end;
            LibCsvFree();
          finally
            hFile.Free();
          end;
          //vytvorime soubor s ciselniky
          s:=GetOfflineDir()+'Ciselniky_gcm.txt';
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): zapis ciselniku do '+s); {$endif}
          StringToFile(aCiselniky.Text,s);
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): konec cteni katalogu'); {$endif}
        end;
{$ifdef READ_GCM_CATALOG}
      end;
{$endif}
    finally
      aCiselniky.Free();
    end;
  end;
  CwgForm.Visible:=true;
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): celkem parsovanych radku: '+IntToStr(n)); {$endif}
  CwgForm_butGcmKat.Cursor:=crDefault;
  CwgForm_TabButtons.Cursor:=crDefault;
  CwgForm_TabImport.Cursor:=crDefault;
  CwgForm.Cursor:=crDefault;
  //CwgForm.Visible:=true;
{$ifdef DEBUG_HELPER} LDH('GcmReadCatalog(): stop'); {$endif}
end;