//prace s API v 2 na gcm serveru

function Gcm2GetDir:string;
begin Result:=GetCwgDir()+'gcm2/'; end;

function Gcm2GetIniPathName:string;
begin Result:=Gcm2GetDir()+'Gcm2Cmds.ini'; end;

{$include Cwg2.Gcm2Token.pas}

function Gcm2JsonToTxt(sJson:string):string;
begin
  Result:=JSEntityDecode(sJson);
  Result:=ReplaceString(Result,',',','+CRLF);
  Result:=ReplaceString(Result,'{','{'+CRLF);
  Result:=ReplaceString(Result,']',']'+CRLF);
end;

//posle prikaz na server a ziska odpoved
function Gcm2SendCmd(sCmd,sParam:string):string;
var b:boolean;
    i,iErr:integer;
    sP:string;
begin
  Result:='';
  i:=0;
  iErr:=0;
  if(sGcm2Token='') then Gcm2ReadToken();
  if(sGcm2Token='') then Gcm2GetTokenFromGcm(GEOGET_OWNER,false);
  i:=0;
  while(i<2) do begin //opakujeme, pokud je problem s prihlasenim uzivatele
    //prazdny token, nahradime jej existujicim, aby byl pouzit ten po novem prihlaseni
    sP:=ReplaceString(sParam,'"token":""','"token":"'+sGcm2Token+'"');
    b:=HttpAsk('POST',sGcm2Url+sCmd,'text/json',sP,Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - i='+IntToStr(i)); {$endif}
{$ifdef DEBUG_HELPER} LDH('Gcm2 - URL='+sGcm2Url+sCmd); {$endif}
{$ifdef DEBUG_HELPER} LDH('Gcm2 - param='+sP); {$endif}
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - navrat='+Result); {$endif}
    if(not b) then begin
      ShowMessage('ERR: Chyba odeslani prikazu: '+sCmd);
      exit;
    end;
    iErr:=Gcm2NeedToken(Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - iErr='+IntToStr(iErr)+' (po NeedToken)'); {$endif}
    if(iErr>1) then exit;
    if(iErr=1) then Gcm2GetTokenFromGcm(GEOGET_OWNER,false);
    if(sGcm2Token='') then begin
      Result:='';
      ShowMessage('ERR: prihlaseni se nezdarilo, s GCM serverem nelze pracovat.');
      exit;
    end;
    if(iErr=0) then break; //podarilo se nacist na prvni pokus
    Inc(i);
  end;
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - navratova hodnota='+Result); {$endif}
end;

//pocka na to, az bude predchozi prikaz (export nebo import dokoncen)
//pokud vrati false, bylo cekani preruseno uzivatelem = abort
function Gcm2WaitForExportComplete(sCmd,sId:string):boolean;
var sParam,sRes,sStat,sNum:string;
begin
  GeoBusyStart();
  GeoBusyCaption('Cekani na server: '+sCmd);
  //CwgForm.Visible:=false;
  Result:=true;
  sParam:='{"token":"", "exportIds": ['+sId+']}';
  while (true) do begin //nekonecna smycka
    if(GeoBusyTest()) then begin //preruseni uzivatelem
      Result:=false;
      break;
    end;
    sRes:=Gcm2SendCmd(sCmd,sParam);
    //zjistime vysledek
    Fetch(sRes,'"exportId":');
    Fetch(sRes,sId);
    Fetch(sRes,'"status"');
    Fetch(sRes,'"'); //zacatek textu statusu
    sStat:=Fetch(sRes,'"');
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - cekani na export, status='+sStat); {$endif}
    //ziskame pocet CWG
    Fetch(sRes,'"pieces"'); Fetch(sRes,':');
    sNum:=Fetch(sRes,',');
    GeoBusyKind('Export CWG ze serveru: '+sNum);
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - cekani na export, pocet zpracovanych='+sNum); {$endif}
    case sStat of
      'waiting',
      'processing': begin
                      Sleep(1000); //pockame sekundu
                      continue;
                    end;
      'done':       break;
      'error':      begin
                      ShowMessage('ERR: Chyba pri zpracovani exportu na serveru');
                      Result:=false;
                      break;
                    end;
    end;
  end;
  //CwgForm.Visible:=true;
end;

function Gcm2Export:string;
var sCmd,sParam,sRes,sId,sFormat:string;
begin
  Gcm2ReadToken();
  Result:='';
  //zavolame pripravu dat
  sCmd:='collection/export';
  sFormat:='fullcsv';
  //sFormat:='fullxml';
  //sFormat:='svetgc';
  //sFormat:='csv';
  //sFormat:='html';
  sParam:='{"token":"", "options": {"format":"'+sFormat+'"}}';
  sRes:=Gcm2SendCmd(sCmd,sParam);
  Fetch(sRes,'"exportId":');    //z odpovedi ziskame ID rozpracovaneho pozadavku
  sId:=Fetch(sRes,'}');
{$ifdef DEBUG_HELPER} LDH('Gcm2 - sId='+sId); {$endif}
  if(sId='') then exit; ///divne, k tomu by dojit nemelo
  //pockame na pripravena data
  if(Gcm2WaitForExportComplete('export/query',sId)=false) then exit;
  //pripravena data stahneme a ulozime do souboru
  sRes:=Gcm2SendCmd('export/get',
    '{"token":"", "exportId":'+sId+'}'
    );
  sRes:=JSEntityDecode(sRes);
  StringToFile(sRes,Gcm2GetDir()+'gcm-export_'+sFormat+'.txt');
end;

function Gcm2User(sCmd,sUser:string):string;
var sParam,sRes:string;
begin
  Result:='';
  Gcm2ReadToken();
  if(sCmd='info') then sParam:='{"token":""}'
  else sParam:='{"token":"", "user":"'+sUser+'"}';
  sRes:=Gcm2SendCmd('user/'+sCmd,sParam);
  StringToFile(Gcm2JsonToTxt(sRes),Gcm2GetDir()+'gcm-user_'+sCmd+'.json');
end;

function Gcm2GetTotalCount(sResponse:string):integer;
var i,iPos:integer;
    s,c:string;
begin
  Result:=0;
  //zjistime pocet polozek
  iPos:=Pos('"totalCount":',sResponse);
  if(iPos>0) then begin
    s:=Copy(sResponse,iPos,100);
    Fetch(s,'"totalCount":');
    for i:=1 to 10 do begin
      if(s[i]<'0') or (s[i]>'9') then begin //hledame prvni neciselny znak
        c:=s[i];
        Result:=StrToInt(Fetch(s,c));
        break;
      end;
    end;
  end;
{$ifdef DEBUG_HELPER} LDH('totalCount='+IntToStr(Result)); {$endif}
end;

function Gcm2Tags(sCmd,sFilter,sDisplay:string; limit,offset:integer; var nItems:integer):string;
  //sFilter filtruje kategorie tagu (systemove, uzivatelske), jejich seznam
  //        a to, zda vracet i kategorie, do nichz neni zarazeno zadne xWG
  //sDisplay definuje pocet zobrazenych kategorii (implicitne 100)
var sParam:string;
begin                  //nacte vsechny tagy, pocet jejich pouziti, rozdeli je podle kategorii
  Result:='';
  Gcm2ReadToken();
  sParam:='{"token":""';
  if(sFilter<>'') then sParam:=sParam+', "filterOptions": '+sFilter;
  if(sDisplay<>'') then sParam:=sParam+', "displayOptions": '
    +ReplaceString(ReplaceString(sDisplay,'"offset":#','"offset":'+IntToStr(offset)),
    '"limit":#','"limit":'+IntToStr(limit));
  sParam:=sParam+'}';
  Result:=Gcm2JsonToTxt(Gcm2SendCmd('tags/'+sCmd,sParam));
  nItems:=Gcm2GetTotalCount(Result);
  StringToFile(Result,Gcm2GetDir()+'gcm-tags_'+sCmd+'-'+IntToStr(offset)+'.json');
end;

procedure Gcm2GetTags;
var sRes,sTagName,sTagCount,sCatId,sCatName:string;
    aCategory:TStringList;
    i,ii,nItems,nLimit,iOffset:integer;
begin
  CwgForm.Hide();
  GeoBusyStart();
  GeoBusyCaption('gcm - xwg.query');
  nItems:=1;
  nLimit:=1000; //krok, po kolika nacitame tagy
  iOffset:=0;
  i:=0;
  ii:=1;
  aCategory:=TStringList.Create();
  try
    while((i<nItems) and (ii>0)) do begin       //zacyklime, dokud neni nacteno vsechno
      GeoBusyProgress(iOffset,nItems);
      ii:=0; //pocet tagu v tomto souboru
      sRes:=Gcm2Tags('query','','{"limit":#, "offset":#, "showItemCount":true}',nLimit,iOffset,nItems);
      //rozebereme a ziskame seznam vsech tagu a k nim pocty a kategorie
      Fetch(sRes,'"tags":[{');
      while (sRes<>'') do begin
        GeoBusyProgress(i,nItems);
        Fetch(sRes,'"name":"');       sTagName:=Fetch(sRes,'"');    //hodnota tagu
        Fetch(sRes,'"itemCount":"');  sTagCount:=Fetch(sRes,'"');   //pocet pouziti
        Fetch(sRes,'"id":"');         sCatId:=Fetch(sRes,'"');      //id kategorie
        Fetch(sRes,'"name":"');       sCatName:=Fetch(sRes,'"');    //jmeno kategorie
        if(sRes='') then break;
        if(aCategory.Values[sCatId]='') then aCategory.Values[sCatId]:=''
        else aCategory.Values[sCatId]:=aCategory.Values[sCatId]+', ';
        aCategory.Values[sCatId]:=aCategory.Values[sCatId]+sTagName+' ('+sTagCount+')';
        Inc(i);
        Inc(ii);
      end;
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+', ii='+IntToStr(ii)+', Items='+IntToStr(nItems)); {$endif}
      iOffset:=iOffset+ii;
    end;
    ShowMessage('Pocet zpracovanych tagu: '+IntToStr(i)+'/'+IntToStr(nItems)+CRLF
               +'Pocet kategorii: '+IntToStr(aCategory.Count));
    StringToFile(aCategory.Text,Gcm2GetDir()+'Tags-category.txt');
  finally
    aCategory.Free();
  end;
  CwgForm.Show();
end;

procedure Gcm2GetCategories;
var sData,sCategory,s:string;
    i,nItems:integer;
    b:boolean;
begin
  //ziskame soubor s hornotami tagu pro zakladni kategorie
  Gcm2Tags('categories','{"categories":["origin","type","country"]}','{"tags":true}',1000,0,nItems);
  //parsujeme ziskana data
  sData:=FileToString(Gcm2GetDir()+'gcm-tags_categories.json');
  Fetch(sData,'"categories":[{');
  while(sData<>'') do begin  //parsujeme vsechny kategorie
    Fetch(sData,'"id":"');
    if(sData='') then break;
    Inc(i);
    sCategory:=sCategory+Fetch(sData,'",')+': ';
    Fetch(sData,'"tags":[{');
    b:=false;
    s:='';
    while ((b=false) and (sData<>'')) do begin//parsujeme vsechny polozky teto kategorie
      Fetch(sData,'"name":"');
      s:=s+Fetch(sData,'"}')+CRLF;
      b:=(sData[1]=']'); //konec jedne kategorie?
    end;
    sCategory:=sCategory+ReplaceString(Trim(s),CRLF,', ')+CRLF; //zapiseme polozky kategorie
  end;
  StringToFile(sCategory,Gcm2GetDir()+'Category-tags.txt');
  ShowMessage('Pocet ziskanych kategorii: '+IntToStr(i));
end;

function Gcm2Xwg(sCmd,sFilter,sDisplay:string; limit,offset:integer; var nItems:integer):string;
  //sFilter filtruje kategorie tagu (systemove, uzivatelske), jejich seznam
  //        a to, zda vracet i kategorie, do nichz neni zarazeno zadne xWG
  //sDisplay definuje pocet zobrazenych kategorii (implicitne 100)
var sParam:string;
begin                  //nacte vsechny tagy, pocet jejich pouziti, rozdeli je podle kategorii
  Result:='';
  Gcm2ReadToken();
  sParam:='{"token":""';
  if(sFilter<>'') then sParam:=sParam+', "filterOptions": '+sFilter;
  if(sDisplay<>'') then sParam:=sParam+', "displayOptions": '
    +ReplaceString(ReplaceString(sDisplay,'"offset":#','"offset":'+IntToStr(offset)),
    '"limit":#','"limit":'+IntToStr(limit));
  sParam:=sParam+'}'
  Result:=Gcm2JsonToTxt(Gcm2SendCmd('xwg/'+sCmd,sParam));
  //zjistime pocet polozek
  nItems:=Gcm2GetTotalCount(Result);
  StringToFile(Result,Gcm2GetDir()+'gcm-xwg_'+sCmd+'-'+IntToStr(offset)+'.json');
end;

procedure Gcm2GetXwg(sTagValue,sTagCategory:string);
var sRes,sRow,sId,sName,sVer,sCatNo,sNote,sTags,sTagVal,sTagCat:string;
    aCwg:TStringList;
    i,ii,nItems,nLimit,iOffset:integer;
    bCategory:boolean;
begin
  CwgForm.Hide();
  GeoBusyStart();
  GeoBusyCaption('gcm - xwg.query');
  nItems:=1;
  nLimit:=100; //krok, po kolika nacitame tagy
  iOffset:=0;
  i:=0;
  ii:=1;
  aCwg:=TStringList.Create();
  try
    while((i<nItems) and (ii>0)) do begin       //zacyklime, dokud neni nacteno vsechno
      GeoBusyProgress(iOffset,nItems);
      ii:=0;      //pocet CWG v tomto souboru
      sRes:=Gcm2Xwg('query'
        ,'{"collected":false, "tags":[{"name":"'+sTagValue+'", "category":"'+sTagCategory+'"}]}'
        ,'{'
          +'"sort":[{"columnName":"name","direction":"ASC"},{"columnName":"version","direction":"ASC"}], '
          +'"limit":#, "offset":#, '
          +'"show":["id","name","version","cat_no","note","tags"'
          //+',"collected","offered","wanted","nowanted","collection","offer"'
          +']}'
        ,nLimit,iOffset,nItems);
      //rozebereme a ziskame seznam vsech polozek
      Fetch(sRes,'"items":[{');
//{$ifdef DEBUG_HELPER} LDH('------- Start zpracovani davky, len='+IntToStr(Length(sRes))+':'+Copy(sRes,1,100)+'...'); {$endif}
      while (sRes<>'') do begin
        GeoBusyProgress(i,nItems);
        Fetch(sRes,'"id":"');         sId:=Fetch(sRes,'",');      //id CWG
//if(sId='614735') then begin
//{$ifdef DEBUG_HELPER} LDH('sRes='+Copy(sRes,1,20)+'...'); {$endif}
//end;
        Fetch(sRes,'"name":"');       sName:=Fetch(sRes,'",');    //hodnota tagu
//if(sId='614735') then begin
//{$ifdef DEBUG_HELPER} LDH('sRes='+Copy(sRes,1,20)+'...'); {$endif}
//end;
        Fetch(sRes,'"version":"');    sVer:=Fetch(sRes,'",');     //pocet pouziti
        //katalogove cislo muze byt null (bez uvozovek), proto hledame bez nich
        Fetch(sRes,'"cat_no":');      sCatNo:=ReplaceString(Fetch(sRes,','),'"','');
        Fetch(sRes,'"note":"');       sNote:=Fetch(sRes,'",'+CRLF);    //poznamka
//if(sId='614735') then begin
//  {$ifdef DEBUG_HELPER} LDH('sId='+sId+', sName='+sName+', sVer='+sVer+', sCatNo='+sCatNo+', sNote='+sNote); {$endif}
//  sRes:='';
//  i:=nLimit;
//  break;
//end;
        sNote:=ReplaceString(sNote,CRLF,' ');
//{$ifdef DEBUG_HELPER} LDH('sId='+sId+', sName='+sName+', sVer='+sVer+', sCatNo='+sCatNo+', sNote='+sNote); {$endif}
        if(sRes='') then break;
        //ted vsechny tagy
        Fetch(sRes,'"tags":[{');
        sTags:='';
        bCategory:=false;
        sTagVal:='';
        sTagCat:='';
        while(sRes<>'') do begin
          sRow:=Fetch(sRes,CRLF);
          if(sRow='}]') then break; //konec vsech tagu pro toto CWG
          if(Pos('"categories":',sRow)>=1) then bCategory:=true;
          if(bCategory) then begin
            if(Pos('"name":"',sRow)>=1) then begin
              //hodnotu ignorujeme, ale je to posledni polozka kategorie, tak tag ulozime
              bCategory:=false;
              if(sTags<>'') then sTags:=sTags+'; ';
              sTags:=sTags+sTagCat+'='+sTagVal;
            end;
            if(Pos('"id":"',sRow)>=1) then begin
              Fetch(sRow,'":"');
              sTagCat:=Fetch(sRow,'"');
            end;
          end
          else begin
            if(Pos('"name":"',sRow)>=1) then begin
              Fetch(sRow,'":"');
              sTagVal:=Fetch(sRow,'"');
            end;
          end;
        end;
        if(sRes='') then break;
        //asi bude problem se jmeny obsahujici '='
        if(aCwg.Values[sName]='') then aCwg.Values[sName]:=''
        else aCwg.Values[sName]:=aCwg.Values[sName]+', ';
        aCwg.Values[sName]:=aCwg.Values[sName]+sCatNo+','+sVer+','+sId+', '+sTags+', '+sNote;
        Inc(i);
        Inc(ii);
      end;
//{$ifdef DEBUG_HELPER} LDH('------- i='+IntToStr(i)+', ii='+IntToStr(ii)+', Items='+IntToStr(nItems)); {$endif}
      //StringToFile(aCwg.Text,Gcm2GetDir()+'xwg-query_'+IntToStr(iOffset)+'.txt');
      iOffset:=iOffset+ii;
    end;
    StringToFile(aCwg.Text,Gcm2GetDir()+'xwg-query.txt');
    ShowMessage('Pocet zpracovanych xwg: '+IntToStr(i)+'/'+IntToStr(nItems));
  finally
    aCwg.Free();
  end;
  CwgForm.Show();
end;

function lGcm2GetSelFunction:string;
var idx:integer;
    sRow,sFce:string;
begin
  Result:='';
  CwgForm_sGcm2Desc.Caption:='';
  idx:=CwgForm_lGcm2Cmds.ItemIndex;
  if(idx<0) then exit;
  sFce:=CwgForm_lGcm2Cmds.Items[idx];
  if(sFce[1]='-') then exit; //je to jen nadpis skupiny funkci
  //najdeme nadpis skupiny funkci
  for idx:=idx-1 downto 0 do begin
    sRow:=CwgForm_lGcm2Cmds.Items[idx];
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - sRow='+sRow); {$endif}
    if(sRow[1]='-') then begin
      Fetch(sRow,' ');
      Result:=sRow+'.'+sFce;
      break;
    end;
  end;
end;

procedure lGcm2CmdsOnClick(Sender: TObject);
var sFce:string;
    ini:TMemIniFile;
begin
  sFce:=lGcm2GetSelFunction();
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - sFce='+sFce); {$endif}
  if(sFce='') then exit;
  ini:=TMemIniFile.Create(Gcm2GetIniPathName());
  try
    CwgForm_sGcm2Desc.Caption:=ini.ReadString(sFce,'Desc',''); //zobrazime popis
  finally
    ini.Free();
  end;
end;

procedure butGcm2OkOnClick(Sender: TObject);
var sFce:string;
begin
  sFce:=lGcm2GetSelFunction();
  sFce:=ReplaceString(sFce,'moje.',''); //odstranime uvodni "umele pridanou" sekci
  case sFce of
  'collection.export': Gcm2Export();
  'user.info': Gcm2User('info','');
  'user.profile': Gcm2User('profile',GCM_USER); //muze tu byt jakykoli uzivatel, toto je na testovani
  'user.statistics': Gcm2User('statistics',GCM_USER); //muze tu byt jakykoli uzivatel, toto je na testovani
  'tags.query':      Gcm2GetTags(); //seznam vsech hodnot tagu s uvedenim poctu a kategorie, do ktere tag patri
  'tags.categories': Gcm2GetCategories(); //seznam kategorii a tagu v nich
  /////////////
  'getMWG': Gcm2GetXwg('MWG','type');
  'getSQ': Gcm2GetXwg('SQ','type');
  'getxWG': Gcm2GetXwg('xWG','type');
  end;
end;

procedure lGcm2NewLoginOnClick(Sender: TObject); //vynuti nove prihlaseni
begin
  Gcm2GetTokenFromGcm(GEOGET_OWNER,true);
end;

procedure InitGcm2;
var i:integer;
    s:string;
begin
  ForceDirectories(Gcm2GetDir());
  CwgForm_butGcm2Ok.OnClick:=@butGcm2OkOnClick;
  CwgForm_butGcm2NewLogin.OnClick:=@lGcm2NewLoginOnClick;
  CwgForm_lGcm2Cmds.OnClick:=@lGcm2CmdsOnClick;
  //vypustit ze seznamu vsechny prikazy, ktere zacinaji *
  for i:=CwgForm_lGcm2Cmds.Items.Count-1 downto 1 do begin
    s:=CwgForm_lGcm2Cmds.Items[i];
    if(s<>'') then
      if(s[1]='*') then CwgForm_lGcm2Cmds.Items.Delete(i);
  end;
end;